routes/web.php
	<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
 */
Route::get('/import', 'Backend\AgencyController@import');
Route::get('/', 'HomeController@index');
Route::get('/sms', 'Backend\SMSController@index');
// Route::get('/t',function(){
//     var_dump(Auth::user()->isAdmin());
// });
// Route::get('/pusher', function() {
//     event(new App\Events\HelloPusherEvent('Hi there Pusher!'));
//     return "Event has been sent!";
// });
// Route::get('/incomingsms', ['uses' => 'Backend\PaymentController@webHook']);
// Route::get('/sendsms',['uses' => 'Backend\PaymentController@sendSMS']);
// Route::get('/vue', function(){
//     return view('layouts.index');
// });
// Route::get('/', function(){
//     return view('index');
// });
// Route::group([
//     'as' => 'be.',
//     'namespace' => 'Backend',
//     'middleware' => ['web','auth']
// ], function(){

//     Route::get('/payments/live', function(){
//         return view('backend.payments.live');
//     })->name('payments.live');
//     /* CATEGORY ROUTES */

//     Route::group([
//         'as' => 'category.',
//         'prefix' => 'category',
//         'middleware' => ['web']
//     ], function(){
//         Route::get('/', ['as' => 'index', 'uses' => 'CategoryController@index']);
//         Route::get('/create',['as' => 'create', 'uses' => 'CategoryController@createForm']);
//         Route::post('/store',['as' => 'store', 'uses' => 'CategoryController@store']);
//         Route::get('/update/{id}',['as' => 'update', 'uses' => 'CategoryController@updateForm']);
//         Route::post('/save',['as' => 'save', 'uses' => 'CategoryController@save']);
//         Route::post('/delete',['as' => 'delete', 'uses' => 'CategoryController@delete']);
//         Route::get('/webhook/{id}',['as' => 'webhook', 'uses' => 'CategoryController@testWebHook']);
//     });
//     Route::resources(
//         [
//             'items' => 'ItemController',
//             'orders' => 'OrderController',
//             'customers' => 'CustomerController',
//             'payments' => 'PaymentController',
//             'agency' => 'AgencyController',
//             'users' => 'UserController',
//             'salesman' => 'SalesmanController'
//         ]
//     );
//     Route::get('/salesman/{saleman}/add-agencies',['as' => 'salesman.addAgencies', 'uses' => 'SalesmanController@addAgencies']);
//     Route::post('/payments/verify/{id}',['as' => 'payments.verify', 'uses' => 'PaymentController@pinVerify']);
//     Route::get('/payments/verify/{id}',['as' => 'payments.verify.input', 'uses' => 'PaymentController@showVerifyForm']);
//     Route::post('/payments/confirm',['as' => 'payments.confirm','uses' => 'PaymentController@confirm']);
//     Route::get('/sms-history', ['as' => 'sms.history', 'uses' => 'SMSController@index']);
//     Route::group([
//         'as' => 'ajax.',
//         'prefix' => 'ajax',
//         'middleware' => ['web']
//     ], function(){
//         Route::group([
//             'as' => 'item.',
//             'prefix' => 'item'
//         ], function(){
//             Route::get('/get', ['as' => 'get', 'uses' => 'ItemController@ajaxGetItem']);
//         });
//         Route::group([
//             'as' => 'customer.',
//             'prefix' => 'customer'
//         ], function(){
//             Route::get('/get', ['as' => 'get', 'uses' => 'CustomerController@ajaxGetCustomer']);
//             Route::post('/get-by-agency',['as' => 'getbyagency', 'uses' => 'CustomerController@ajaxGetCustomerByAgency']);
//         });
//     });
//     //PROVINCE, WARD, DISTRICT AJAX ROUTES
//     Route::group([
//         'as' => 'address.'
//     ],function(){
//         Route::post('/districts-by-province',['as' => 'district.byProvince','uses' => 'AddressController@getDistrictsByProvinceId']);
//         Route::post('/wards-by-district',['as' => 'ward.byDistrict','uses' => 'AddressController@getWardsByDistrictId']);
//     });
// });

//Auth::routes();

// Route::get('/home', 'HomeController@index')->name('home');

app/Models/Eloquent/Salesman.php
<?php

namespace App\Models\Eloquent;

use Illuminate\Database\Eloquent\Model;

class Salesman extends User
{
    protected $table = "users";
    public static function all($columns = ['*']){
        return User::with('role','agencies')->whereHas('role',function($query){
            $query->where('name','sale');
        })->get();
    }

}

app/Http/Controllers/API/SalesmanController.php
<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Contracts\AgencyRepositoryInterface;
use App\Models\Contracts\SalesmanRepositoryInterface;
use App\Models\Eloquent\Agency;
use App\Models\Eloquent\Payment;
use App\Models\Eloquent\User;
use Config;

class SalesmanController extends Controller
{
    private $salesmanRepository;
    private $agencyRepository;

    public function __construct(AgencyRepositoryInterface $agencyRepository, SalesmanRepositoryInterface $salesmanRepository)
    {
        $this->salesmanRepository = $salesmanRepository;
        $this->agencyRepository = $agencyRepository;
    }
    public function get()
    {
        $salesmen = User::salesman()->withCount(['agencies','payments'])->get();
        return $salesmen;
    }
    public function getById(Request $request)
    {
        $id = $request->id;
        $salesman = User::salesman()->with(['agencies.province','agencies.district','agencies.ward','roles'])->find($id);
        return response()->json($salesman);
    }
    public function getAgencies(Request $request,$salesman_id)
    {
        $agencies = $this->agencyRepository->getAllBySaleId($salesman_id);
        return response(['data' => $agencies], 200);
    }
    public function update(Request $request)
    {
        $posted_salesman = $request->salesman;
        $salesman = User::findOrFail($posted_salesman['id']);

        $salesman->name = $posted_salesman['name'];
        $salesman->email = $posted_salesman['email'];
        $salesman->phone =$posted_salesman['phone'];
        try{
            $salesman->update();
            return response()->json(['status' => true, 'msg' => 'Cập nhật thành công!', 'data' => $salesman]);
        }catch(\Exception $e)
        {
            return response()->json(['status' => false, 'msg' => 'Cập nhật thất bại. Lỗi: '.$e->getMessages(), 'data' => $salesman]);
        }
    }
    public function addAgencies(Request $request){
        $agency_ids = $request->agency_ids;
        $sale_id = $request->sale_id;
        $saved = Agency::whereIn('id',$agency_ids)->update(['sale_id' => $sale_id]);
        return response($saved);
    }
    public function deleteAgency(Request $request)
    {
        $sale_id = $request->sale_id;
        $agency_id = $request->agency_id;
        $saved = Agency::where('id',$agency_id)->update(['sale_id' => null]);
            return response()->json(['status' => $saved]);
        
    }
    public function syncAgencies(Request $request)
    {
        $sale_id = $request->sale_id;
        $newAgencies = $request->new_agencies;
        $noSaleAgencies = $request->no_sale_agencies;
        try{
            foreach($newAgencies as $agency)
            {
                $db_agency = Agency::findOrFail($agency['id']);
                $db_agency->sale_id = $sale_id;
                $db_agency->update();
            }
            foreach($noSaleAgencies as $agency)
            {
                $db_agency = Agency::findOrFail($agency['id']);
                $db_agency->sale_id = null;
                $db_agency->update();
            }
            $salesman = User::salesman()->with(['agencies.province','agencies.district','agencies.ward','roles'])->find($sale_id);
            return response()->json(['status' => true, 'msg' => 'Cập nhật thành công', 'data'=>$salesman]);
        }catch(\Exception $e){
            $salesman = User::salesman()->with(['agencies.province','agencies.district','agencies.ward','roles'])->find($sale_id);
            return response()->json(['status' => true, 'msg' => 'Cập nhật thất bại. Lỗi: '.$e->getMessage(), 'data'=>$id]);
        }

    }

}

app/Http/Controllers/Backend/AddressController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Eloquent\Province;
use App\Models\Eloquent\District;
use App\Models\Eloquent\Ward;

class AddressController extends Controller
{
    public function getDistrictsByProvinceId(Request $request)
    {
        $province_id = $request->province_id;
        $districts = District::where('province_id',$province_id)->get();
        return response()->json($districts);
    }
    public function getWardsByDistrictId(Request $request)
    {
        $wards = Ward::where('district_id',$request->district_id)->get();
        return response()->json($wards);
    }
    public function test()
    {
        $string = file_get_contents('provinces.json');
        $provinces = json_decode($string);  
        // var_dump($provinces);
        // die;
        foreach($provinces as $j_province)
        {
            $province = Province::where('name',trim($j_province->name))->first();
            if($province)
            {
               $province->post_code = $j_province->new_code;
               $province->update();
            }else{
                echo "Not Found:".$j_province->name;
            }
        }
    }
}

app/Http/Controllers/Backend/AgencyController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Contracts\AgencyRepositoryInterface;
use App\Models\Eloquent\Ward;
use App\Models\Eloquent\District;
use App\Models\Eloquent\Province;
use App\Models\Eloquent\Customer;
use App\Models\Eloquent\Agency;
use App\Models\Eloquent\User;
use Hash;
use Session;
use DB;

class AgencyController extends Controller
{
    private $agencyRepository;

    public function __construct(AgencyRepositoryInterface $agencyRepository)
    {
        $this->agencyRepository = $agencyRepository;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //$agencies = $this->agencyRepository->getAll();
      
        // $agencies = Agency::all();
        return view('backend.agency.index', compact('agencies'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $salesmen = User::salesman()->orderBy('name','asc')->get();
        $provinces = Province::all();
        return view('backend.agency.create')->withProvinces($provinces)->withSalesmen($salesmen)    ;
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $customer = Customer::create($request->only(['fullname','email','phone_number','gender']));
        $agency = new Agency();
        $agency->name = $request->name;
        $agency->address = $request->address;
        $agency->province_id = $request->province_id;
        $agency->district_id = $request->district_id;
        $agency->ward_id = $request->ward_id;
        if($request->has('sale_id') && $request->sale_id != 0){
            $agency->sale_id = $request->sale_id;
        }
        
        if($agency->save()){
            Session::flash('message','Tạo mới đại lý thành công');
            Session::flash('alert-class','alert-success');
            $customer->agency_id = $agency->id;
            $customer->is_owner = 1;
            $customer->update();
        }
       

            Session::flash('message','Tạo mới đại lý không thành công');
            Session::flash('alert-class','alert-danger');

        return redirect()->route('be.agency.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $agency = Agency::with('customers')->where('id',$id)->first();
        return view('backend.agency.edit',compact('agency'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $agency = Agency::with(['province','district','ward','customers','salesman'])->where('id',$id)->first();
        $owner = Customer::where('agency_id',$id)->where('is_owner',1)->first();
     //   DB::enableQueryLog();
        $provinces = Province::all();
        $statisticYearRevenue = DB::table('payments')
        ->whereYear('created_at',date('Y'))
        ->where('agency_id',$id)
        ->select(DB::raw('SUM(amount) as total, MONTH(created_at) as month, YEAR(created_at) as year'))
        ->groupBy(DB::raw('YEAR(created_at) ASC, MONTH(created_at) ASC'))->get()->toArray();
      //  dd(DB::getQueryLog());

    
        $monthsLabels = array();
        $monthsRevenues = array();
        foreach($statisticYearRevenue as $statistic)
        {
            array_push($monthsLabels, $statistic->month);
            array_push($monthsRevenues, $statistic->total);
        }


        $yearchartjs = app()->chartjs
        ->name('yearRevenueChart')
        ->type('line')
        ->size(['width' => 400, 'height' => 200])
        ->labels($monthsLabels)
        ->datasets([
            [
                "label" => "Doanh số trong năm ".date('Y'),
                'backgroundColor' => "rgba(38, 185, 154, 0.31)",
                'borderColor' => "rgba(38, 185, 154, 0.7)",
                "pointBorderColor" => "rgba(38, 185, 154, 0.7)",
                "pointBackgroundColor" => "rgba(38, 185, 154, 0.7)",
                "pointHoverBackgroundColor" => "#fff",
                "pointHoverBorderColor" => "rgba(220,220,220,1)",
                'data' => $monthsRevenues,
            ],
        ])
        ->options([
            'height'=> 300,
        ]);

        return view('backend.agency.edit',compact('agency','yearchartjs','owner','provinces'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $agency = $this->agencyRepository->find($id);
        $agency->name = $request->name;
        $agency->address = $request->address;
        if($agency->update())
        {
            Session::flash('message','Cập nhật thông tin đại lý thành công');
            Session::flash('alert-class','alert-success');
        }
            Session::flash('message','Error! Không cập nhật được thông tin đại lý!');
            Session::flash('alert-class','alert-danger');

        return redirect()->route('be.agency.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    public function import()
    {
        $agencies = file_get_contents('agencies.json');
        $agencies = json_decode($agencies);
        //  print_r($agencies[0]->A);
        //  die;
         $i = 1;
       //  return true;
        foreach($agencies as $raw_agency)
        {
          //  var_dump($agency[1]);
            // die;
            if($raw_agency !== null && $raw_agency->D !== null){
                $agency = new Agency();
                $agency->name = preg_replace('/\s\s+/', ' ',trim($raw_agency->B));
                $agency->address = $raw_agency->C;
                $agency->save();
              
                if($raw_agency->D !== null){
                    $owner = new Customer();
                    $owner->fullname = $agency->name;
                    $owner->phone_number = trim($raw_agency->D);
                    $owner->is_owner = 1;
                    $owner->agency_id = $agency->id;
                    $owner->save();
                }
                if($raw_agency->E !==null){
                    $sale = User::where('name',trim($raw_agency->E))->first();
                    if(empty($sale))
                    {
                        $phone_str = str_replace(' ','',$raw_agency->F);
                        $phone_1 = $phone_str;
                        $phone_2 = '';
                        if(strpos($phone_str,'-') !== false)
                        {
                            $phone_arr = explode('-',$phone_str);
                            $phone_1 = $phone_arr[0];
                            $phone_2 = $phone_arr[1];
                        }
                        $sale = User::create(['name' => $raw_agency->E,'phone' => $phone_1,'phone1' => $phone_2,'email' => 'sale_'.$i.'@mtk.com.vn', 'password' => Hash::make('12345678')]);
                        $sale->roles()->attach(1);
                        $i++;
                    }
                    $agency->sale_id = $sale->id;
                    $agency->update();   

                }
               
                
            }
          
                //die;
            // echo $agency[1]."<br>";
            // echo $agency[2]."<br>";
            // echo $agency[3]."<br>";
            // echo "<hr>";
        }


    }
}

app/Http/Controllers/Backend/DefaultController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class DefaultController extends Controller
{
    //
}

resources/views/backend/salesman/addAgencies.blade.php
@extends('backend.layouts.index')
@section('title','Thêm đại lý cho nhân viên '.$salesman->name)
@section('page-title','Thêm đại lý cho nhân viên '.$salesman->name)
@section('parent-breadcrumb','Nhân viên bán hàng')
@section('child-breadcrumb','Thêm đại lý')
@section('content')
<div class="col-lg-12">
    <form>
        <div class="box box-success">
            <div class="box-header">
                <h3 class="box-title">Thêm đại lý</h3>
                <div class="margin pull-right">
                    <button class="btn btn-flat btn-success =" name="save" type="submit" id="save"><i class="fas fa-save"></i>Lưu</button>
                <button class="btn btn-flat btn-success" name="save-continue" type="submit">
                    <i class="fas fa-save"></i>Lưu và tiếp tục chỉnh sửa</button>
                    <a href="{{ route('be.salesman.index') }}"><button class="btn btn-flat btn-danger" name="cancel" type="button">
                            <i class="fas fa-times"></i>Cancel</button></a>
                </div>

            </div>
            <div class="box-body">                     
                           <div class="box">
                               <div class="box-header">
                               <h3 class="box-title">Danh sách đại lý chưa có Sale phụ trách</h3>
                                </div>
                               <div class="box-body">
                                    <span>Tổng số đại lý nhân viên đang quản lý: </span><span class="label label-success">{{ $salesman->agencies_count }}</span><br>

                                   <span>Tổng số đại lý đã lựa chọn: </span><span class="label label-info" id="selectedCount">0</span>
                                   <div class="filter row">
                                        <div class="col-md-12">
                                        </div>
                                   </div>
                                    <table class="table" id="agenciesTable">
                                        <thead>
                                            <tr>
                                            <th></th>
                                            <th>Mã ĐL</th>
                                            <th>Tên đại lý</th>
                                            <th>Địa chỉ</th>
                                            <th>Xã/Phường</th>
                                            <th>Quận/Huyện</th>
                                            <th>Tỉnh/Thành</th>
                                        </tr>
                                        <tr>
                                                <th></th>
                                                <th>Mã ĐL</th>
                                                <th>Tên đại lý</th>
                                                <th>Địa chỉ</th>
                                                <th>Xã/Phường</th>
                                                <th>Quận/Huyện</th>
                                                <th>Tỉnh/Thành</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                       
                                        </tbody>
                                        <tfoot>
                                            <tr>
                                                <th></th>
                                                <th>Mã ĐL</th>
                                                <th>Tên đại lý</th>
                                                <th>Địa chỉ</th>
                                                <th>Xã/Phường</th>
                                                <th>Quận/Huyện</th>
                                                <th>Tỉnh/Thành</th>
                                            </tr> 
    
                                            </tfoot>
                                    </table>
                                    <button class="btn btn-success">Thêm mới đại lý
                                    </button>
                               </div>
                           </div>
                </div>
        </div>
    </form>
</div>
@endsection
@section('scripts')
<script>
    // $('#agenciesTable thead tr:eq(1) th').each( function (i) {
    //     if(i>0){
    //         var title = $('#agenciesTable thead th').eq( $(this).index() ).text();
    //     $(this).html( '<input type="text" placeholder="Search '+title+'" data-index="'+i+'" />' );
    //     }
        
    // } );
    var table = $("#agenciesTable").DataTable({
        'ajax': "{{ route('api.agency.notHaveSale') }}",
        "processing": true,
        "deferRender": true,
        aoColumns:[
            { "data" : 'id',
              render: function(data, type, row)
              {
                  return '';
              },
              orderable: false,
              className: 'select-checkbox',
            },
            { "data" : "id" },
            { "data" : "name" },
            { "data" : "address" },
            { "data" : "ward.name" },
            { "data" : "district.name" },
            { "data" : "province.name" },
           
        ],
        dom: 'Bfrtip',
        buttons: [  
            {
            extend: 'selectAll',
            text: 'Chọn tất cả',
            action:  function (e) {
                e.preventDefault();
                table.rows({ search: 'applied'}).deselect();
                table.rows({ search: 'applied'}).select()

             }
            },
            // 'selectAll',
            // 'selectNone',
            {
            extend: 'selectNone',
            text: 'Bỏ chọn tất cả',
            // 'selectAll',
            // 'selectNone',
            },
            {
            extend: 'selected',
            text: 'Hiển thị các đại lý đã chọn',
            action: function ( e, dt, button, config ) {
                if (button.text() == 'Hiển thị các đại lý đã chọn') {
                    dt.rows({ selected: false }).nodes().to$().css({"display":"none"});
                    button.text('Hiện tất cả');
                }
                else {
                    dt.rows({ selected: false }).nodes().to$().css({"display":"table-row"});
                    button.text('Hiển thị các đại lý đã chọn');
                }
            }
        }
        ],
           
        select: {
                style:    'multi',
                selector: 'td:first-child'
        },
        initComplete: function () {
            this.api().columns().every( function () {
                var column = this;
                if(this.indexes()[0] > 1){
                    var select = $('<select class="form-control"><option value=""></option></select>')
                    .appendTo( $(column.header()).empty() )
                    .on( 'change', function () {
                        var val = $.fn.dataTable.util.escapeRegex(
                            $(this).val()
                        );
 
                        column
                            .search( val ? '^'+val+'$' : '', true, false )
                            .draw();
                    } );
 
                column.data().unique().sort().each( function ( d, j ) {
                    select.append( '<option value="'+d+'">'+d+'</option>' )
                } );
                }

            } );
        },
    });
    table.on('select',function(e, dt, type, indexes){
        $("#selectedCount").html(table.rows( { selected: true } ).count());
    });
    table.on('deselect',function(e, dt, type, indexes){
        $("#selectedCount").html(table.rows( { selected: true } ).count());
    });
    $("#save").click(function(e){
        e.preventDefault();
        var ids = $.map(table.rows({selected:true}).data(), function (item) {
        return item.id;
        });
        $.ajax({
            url: "{{ route('api.salesman.addAgencies') }}",
            method: 'post',
            data:{
                agency_ids: ids,
                sale_id : '{{ $salesman->id }}'
            },
            success: function(data){
                console.log(data);
            }
        });
    });
</script>
@endsection

resources/views/backend/salesman/index.blade.php
@extends('backend.layouts.index')
@section('title','Nhân viên bán hàng')
@section('page-title','Nhân viên bán hàng')
@section('parent-breadcrumb','Catalogue')
@section('child-breadcrumb','Nhân viên bán hàng')
@section('content')
	<div class="col-lg-12">
		<div class="box">
			<div class="box-header">
			<h3 class="box-title">Danh sách</h3>
			<a href="{{ route('be.salesman.create') }}"><button class="btn btn-flat btn-success pull-right"><i class="fa fa-plus"></i>Tạo mới</button></a>
			</div>
			<div class="box-body">
				<table class="mdl-data-table" id="salesmanTale" width="100%">
					<thead>
						<th>Mã NV</th>
						<th>Họ Tên</th>
                        <th>Email</th>
						<th>Số đại lý</th>
						<th>Số giao dịch đã thực hiện</th>
						<th>Doanh só</th>
						<th>Trạng thái</th>
						<th>Ngày tạo</th>
						<th>Action</th>
					</thead>
					<tbody>
						@foreach($salesmen as $salesman)
						<tr>
							<td>{{ $salesman->id }}</td>

							<td>{{ $salesman->name }}</td>
							<td>{{ $salesman->email }}</td>
							
							<td>
								{{ $salesman->agencies_count }}
							</td>
							<td>{{ $salesman->payments_count }}</td>
							<td>
								{!! number_format($salesman->revenue) !!}
							</td>
							<td>{!! $salesman->status_label !!}</td>
							<td><a href="javascript:void(0)" title="{{ date('d/m/Y H:i:s', strtotime($salesman->created_at)) }}">{{ \Carbon\Carbon::parse($salesman->created_at)->diffForHumans() }}</a></td>
							<td><a href="{{ route('be.salesman.edit',$salesman->id) }}"><button class="btn btn-default"><i class="fas fa-edit"></i> Edit</button></a></td>
						</tr>
						@endforeach
					</tbody>
				</table>
			</div>
		</div>
	</div>
@endsection
@section('scripts')
<script>
	$("#salesmanTale").DataTable({ 


	});
</script>
@endsection